jQuery(function ($) {

    wbk_init_backend_tab_menu();

    if( jQuery( '.schedule_tools_date_range' ).length > 0 ){
        jQuery( '.schedule_tools_date_range' ).datepick( {rangeSelect: true, monthsToShow: 3 } );
        jQuery( '.schedule_tools_date_range_exclude' ).datepick( {multiSelect: 999, monthsToShow: 3 } );
        jQuery( '.schedule_tools_days_of_week' ).chosen();
    }

    jQuery('.custom-select-wb > select').niceSelect();

    jQuery('.color-picker-wb').on('input', function() {
        jQuery(this).parent().find('.input-text-color-wb').val( jQuery(this).val()  );

    });
    jQuery('.input-text-color-wb').on('input', function() {
        jQuery(this).parent().find('.color-picker-wb').val( jQuery(this).val() );

    });
    jQuery('.input-wb').on('input', function() {
        wbk_update_appearance_preview( jQuery(this) );
    });

    jQuery('.input-wb').each(function() {
        wbk_update_appearance_preview( jQuery(this) );
    });

    jQuery( '.wbk_schedule_tools_category_id, .wbk_schedule_tools_service_id' ).change( function(){
        jQuery( '.wbk_schedule_tools_category_id, .wbk_schedule_tools_service_id' ).not(this).val(0);
        jQuery( '.wbk_schedule_tools_category_id, .wbk_schedule_tools_service_id' ).niceSelect('update');
    });

    jQuery('.schedule_tools_start_btn').click( function(){
        jQuery('.wbk-error-label').removeClass('wbk-error-label');
        var appearance_data = [];
        var btn = jQuery(this);
        var form_data = new FormData();

        form_data.append( 'action', 'wbk_schedule_tools_action' );
        form_data.append( 'nonce', wbk_dashboardl10n.wbkb_nonce );

        const tab = jQuery('.appearance-tabs-wb').find('.active-wb');

        var error_status = 0;

        var action;
        if( tab.find('.schedule-tools-action-lock').is(':checked')  ){
            action = 'lock';
        } else {
            action = 'unlock';
        }

        var service_id = tab.find('.wbk_schedule_tools_service_id').val();
        var category_id = tab.find('.wbk_schedule_tools_category_id').val();
    	if( service_id == 0 && category_id == 0 ){
    		tab.find( '.wbk_schedule_tools_service_id, .wbk_schedule_tools_category_id').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
     		error_status = 1;
    	}

        var date_range = tab.find('.schedule_tools_date_range').val().trim();
        if( date_range == '' ){
            tab.find('.schedule_tools_date_range').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
            error_status = 1;
        }
        var days_of_week = tab.find('.schedule_tools_days_of_week').val();
        if( days_of_week.length == 0){
            tab.find('.schedule_tools_days_of_week').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
            error_status = 1;
        }
        for (var i = 0; i < days_of_week.length; i++) {
            if( !wbk_check_integer_min_max( days_of_week[0], 1, 7 ) ){
                tab.find('.schedule_tools_days_of_week').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
                error_status = 1;
            }
         }



        var exclude_range;
        var from;
        var to;
        if( tab.attr('data-name') == 'date_auto_lock' ){
            var excluded_dates = tab.find('.schedule_tools_date_range_exclude').val().trim();
        } else {
            from = parseInt( tab.find('.schedule_tools_time_from').val() );
            to = parseInt( tab.find('.schedule_tools_time_to').val() );
            if( from >= to ){
                tab.find('.schedule_tools_time_from').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
                tab.find('.schedule_tools_time_to').closest('.field-block-wb').find('.label-wb').addClass('wbk-error-label');
                error_status = 1;
            }
        }

        if( error_status == 1 ){
            return;
        }

        form_data.append('lock_action', action );
        form_data.append('category', category_id );
        form_data.append('service', service_id);
        form_data.append('date_range', date_range);
        form_data.append('days_of_week', days_of_week);

        if( tab.attr('data-name') == 'date_auto_lock' ){
            form_data.append('exclude_dates', excluded_dates );
            form_data.append('lock_target', 'dates');
        } else {
            form_data.append('from', from);
            form_data.append('to', to);
            form_data.append('lock_target', 'timeslots');
        }
        wbk_change_button_status( btn, 'loading' );
        jQuery.ajax({
            url: wbk_dashboardl10n.ajaxurl,
            type: 'POST',
            data: form_data,
            cache: false,
            processData: false,
            contentType: false,
            success: function( response ) {
                wbk_change_button_status( btn, 'regular' );
                const result = JSON.parse(response);
                wbk_show_backend_notification( result.message );
            }
        });
    });

    jQuery('.color-picker-wb').trigger('change');
    jQuery('#wbk_appearance_field_4').trigger('change');

    jQuery('.color-picker-wb').each(function(){
        wbk_update_appearance_preview(jQuery(this));
    });
    wbk_update_appearance_preview(jQuery('#wbk_appearance_field_4'));
    jQuery('.button-wb-appearance-save').click( function(){
        var appearance_data = [];
        var btn = jQuery(this);
        wbk_change_button_status( btn, 'loading' );
        jQuery('.input-wb[type=text], .input-wb[type=number]').each(function() {
            var classes =  jQuery(this).attr( 'data-class' ).split(',');
            for (i = 0; i < classes.length; i++) {
                var appearance_item = {
                    'class': classes[i],
                    'property': jQuery(this).attr( 'data-property' ),
                    'value': jQuery(this).val(),
                    'id': jQuery(this).attr('id')
                }
                appearance_data.push(  appearance_item   );
            }
        });
        var form_data = new FormData();
        var name = jQuery.trim( jQuery( '[name="wbk-name"]' ).val() );
        form_data.append( 'appearance_data', JSON.stringify( appearance_data )  );
        form_data.append( 'action', 'wbk_save_appearance' );
        form_data.append( 'nonce', wbk_dashboardl10n.wbkb_nonce );
        jQuery.ajax({
            url: wbk_dashboardl10n.ajaxurl,
            type: 'POST',
            data: form_data,
            cache: false,
            processData: false,
            contentType: false,
            success: function( response ) {
                wbk_change_button_status( btn, 'regular' );
                wbk_show_backend_notification( 'Appearance settings saved. Please, don\'t forget to clear the cache in your browser.' );
            }
        });
    });

});

function wbk_update_appearance_preview( elem ){
    var target_classes = elem.attr( 'data-class' ).split(',');
    for (i = 0; i < target_classes.length; i++) {
        var target_property =  elem.attr( 'data-property' );
        var target_value = elem.val();
        if( target_property == 'border-radius'){
            target_value = target_value + 'px';
        }
        jQuery( '.' + target_classes[i] ).css( target_property, target_value );
    }
}

function wbk_change_button_status( elem, status ){
    if( status == 'loading' ){
        elem.addClass('loading-btn-wb');
        elem.find('.btn-ring-wb').css('opacity', '1');
        elem.attr('disabled', true);
    }
    if( status == 'regular' ){
        elem.removeClass('loading-btn-wb');
        elem.find('.btn-ring-wb').css('opacity', '0');
        elem.attr('disabled', false);
    }
}

function wbk_show_backend_notification( message ){
    var top = ( jQuery('.notification-bar-wb').length + 1 )* 60 + 'px';
    var message_html = '<div style="top:' + top  +  ';" class="notification-bar-wb" data-js="notification-bar-wb"><span class="block-icon-wb"><img src= "' + wbk_dashboardl10n.nofication_icon + '"></span><div class="block-text-wb">' + message + '</div><span class="block-close-wb" data-js="block-close-wb"></span></div>';
    jQuery('#wpbody-content').prepend( message_html );
    jQuery('.notification-bar-wb').first().delay(5000).fadeOut('slow', function(){jQuery(this.remove())});
    jQuery('.notification-bar-wb').first().find('.block-close-wb').click( function(){
        jQuery(this).closest('.notification-bar-wb').remove();
    })

}


function wbk_init_backend_tab_menu(){
	jQuery('[data-js="appearance-menu-wb"]').each(function(){
		var jQueryappearance_menu_li = jQuery(this).find('li');
		jQueryappearance_menu_li.click(function(){
			var appearance_menu_li_name = jQuery(this).attr('data-name');
			jQueryappearance_menu_li.removeClass('active-wb');
			jQuery(this).addClass('active-wb');
			jQuery('[data-js="appearance-tabs-wb"] [data-js="single-tab-wb"]').removeClass('active-wb');
			jQuery('[data-js="appearance-tabs-wb"] [data-js="single-tab-wb"][data-name='+ appearance_menu_li_name +']').addClass('active-wb');
		});
	});
}
